/* -*- mode: c++; c-basic-offset: 2; -*- */

#ifndef GENERAL__THREAD_HH
#define GENERAL__THREAD_HH

#include <pthread.h>
#include <signal.h>

#include "general/mutexlock.hh"

namespace General
{
  class Thread
  {
  public:
    typedef pthread_t thread_type;

    Thread( );
    virtual ~Thread( );

    void Cancel( ) const;

    void Detach( ) const;

    void Join( ) const;

    bool IsAlive( ) const;

    void Kill( int Signal ) const;

    void Start( );

    bool operator==( const Thread& Source );

  protected:
    virtual void run( ) = 0;

  private:
    mutable thread_type		m_tid;
    mutable MutexLock::lock_type	m_key;

    static Thread* start_routine( Thread* ThreadSource );
  };
}

#endif /* GENERAL__THREAD_HH */
